"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _newArrowCheck(innerThis, boundThis) { if (innerThis !== boundThis) { throw new TypeError("Cannot instantiate an arrow function"); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * @class ./Validator/Validator
 */
var Validator = function Validator() {
    var _this = this;

    _classCallCheck(this, Validator);

    Object.defineProperty(this, "errors", {
        enumerable: true,
        writable: true,
        value: []
    });
    Object.defineProperty(this, "validate", {
        enumerable: true,
        writable: true,
        value: function value(_value, constraints) {
            _newArrowCheck(this, _this);

            var errors = this.errors;

            constraints.forEach(function (constraint) {
                constraint.setValue(_value);

                if (!constraint.isValid()) {
                    errors = [].concat(_toConsumableArray(errors), [constraint.getMessage()]);
                }
            });

            return errors;
        }.bind(this)
    });
    Object.defineProperty(this, "getErrors", {
        enumerable: true,
        writable: true,
        value: function value() {
            _newArrowCheck(this, _this);

            return this.errors;
        }.bind(this)
    });
}
/**
 * Collects all errors that appeared during validation.
 *
 * @type {Array}
 */


/**
 * Validates passed value by constraints. In this case
 * constraints consists array of classes such as:
 *
 *  - NotBlank
 *  - IsNumber
 *  - Url
 *  - Range
 *
 * @param {*} value
 * @param {Array} constraints
 *        [
 *          Url(),
 *          NotBlank(),
 *          ...
 *        ]
 *
 * @returns {Array}
 */


/**
 * Returns errors.
 *
 * @returns {Array}
 */
;

exports.default = Validator;