'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _Constraint2 = require('../Constraint');

var _Constraint3 = _interopRequireDefault(_Constraint2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _newArrowCheck(innerThis, boundThis) { if (innerThis !== boundThis) { throw new TypeError("Cannot instantiate an arrow function"); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @class ./constraints/Basic/Contains
 */
var Contains = function (_Constraint) {
    _inherits(Contains, _Constraint);

    /**
     * Constructor.
     *
     * @param {Array} filter
     * @param {String} errorMessage
     */
    function Contains() {
        var _this2 = this;

        var filter = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        var errorMessage = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

        _classCallCheck(this, Contains);

        var _this = _possibleConstructorReturn(this, (Contains.__proto__ || Object.getPrototypeOf(Contains)).call(this));

        Object.defineProperty(_this, 'isValid', {
            enumerable: true,
            writable: true,
            value: function value() {
                _newArrowCheck(this, _this2);

                var isValid = false;

                if (_this.filter.includes(_this.value)) {
                    isValid = true;
                }

                return isValid;
            }.bind(this)
        });


        _this.message = 'Value does not contain.';
        _this.filter = filter;

        if (filter.length === 0) {
            _this.filter = ['0', '1'];
        }

        if (errorMessage !== '') {
            _this.message = errorMessage;
        }
        return _this;
    }

    /**
     * Validates passed value.
     *
     * @returns {Boolean}
     */

    /**
     * @type {Array}
     */


    return Contains;
}(_Constraint3.default);

exports.default = Contains;