'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _Constraint2 = require('../Constraint');

var _Constraint3 = _interopRequireDefault(_Constraint2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _newArrowCheck(innerThis, boundThis) { if (innerThis !== boundThis) { throw new TypeError("Cannot instantiate an arrow function"); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @class constraints/Basic/MaxLength
 */
var MaxLength = function (_Constraint) {
    _inherits(MaxLength, _Constraint);

    /**
     * Constructor.
     *
     * @param {Number} reference
     * @param {String} errorMessage
     */
    function MaxLength(reference) {
        var _this2 = this;

        var errorMessage = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

        _classCallCheck(this, MaxLength);

        var _this = _possibleConstructorReturn(this, (MaxLength.__proto__ || Object.getPrototypeOf(MaxLength)).call(this));

        Object.defineProperty(_this, 'reference', {
            enumerable: true,
            writable: true,
            value: 0
        });
        Object.defineProperty(_this, 'setReference', {
            enumerable: true,
            writable: true,
            value: function value(_value) {
                _newArrowCheck(this, _this2);

                _this.reference = _value;

                return _this;
            }.bind(this)
        });
        Object.defineProperty(_this, 'isValid', {
            enumerable: true,
            writable: true,
            value: function value() {
                _newArrowCheck(this, _this2);

                var isValid = false;

                if (_this.value.length < _this.reference) {
                    isValid = true;
                }

                return isValid;
            }.bind(this)
        });


        if (reference) {
            _this.setReference(reference);
        }

        _this.message = 'Maximum length must be a ' + _this.reference + ' characters';

        if (errorMessage !== '') {
            _this.message = errorMessage;
        }
        return _this;
    }

    /**
     * Sets the value as reference for validation.
     *
     * @param {Number} value
     *
     * @returns {Object}
     */

    /**
     * @type {Number}
     */


    /**
     * Validates passed value.
     *
     * @returns {Boolean}
     */


    return MaxLength;
}(_Constraint3.default);

exports.default = MaxLength;