'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _Constraint2 = require('../Constraint');

var _Constraint3 = _interopRequireDefault(_Constraint2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _newArrowCheck(innerThis, boundThis) { if (innerThis !== boundThis) { throw new TypeError("Cannot instantiate an arrow function"); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @class ./constraints/Basic/IsNumber
 */
var IsNumber = function (_Constraint) {
    _inherits(IsNumber, _Constraint);

    /**
     * Constructor.
     *
     * @param {String} errorMessage
     */
    function IsNumber() {
        var _this2 = this;

        var errorMessage = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

        _classCallCheck(this, IsNumber);

        var _this = _possibleConstructorReturn(this, (IsNumber.__proto__ || Object.getPrototypeOf(IsNumber)).call(this));

        Object.defineProperty(_this, 'pattern', {
            enumerable: true,
            writable: true,
            value: '^-?[0-9]\\d*(\\.\\d+)?$'
        });
        Object.defineProperty(_this, 'isValid', {
            enumerable: true,
            writable: true,
            value: function value() {
                _newArrowCheck(this, _this2);

                var isValid = false;
                var regex = new RegExp(_this.pattern);

                if (regex.test(_this.value)) {
                    isValid = true;
                }

                return isValid;
            }.bind(this)
        });

        _this.message = 'Value is not a number.';

        if (errorMessage !== '') {
            _this.message = errorMessage;
        }
        return _this;
    }

    /**
     * Validates passed value.
     *
     * @returns {Boolean}
     */

    /**
     * @type {String}
     */


    return IsNumber;
}(_Constraint3.default);

exports.default = IsNumber;