'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Constraint2 = require('../Constraint');

var _Constraint3 = _interopRequireDefault(_Constraint2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _newArrowCheck(innerThis, boundThis) { if (innerThis !== boundThis) { throw new TypeError("Cannot instantiate an arrow function"); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @class ./services/Validator/Constraints/Basic/Range
 */
var Range = function (_Constraint) {
  _inherits(Range, _Constraint);

  /**
   * Constructor
   *
   * @param {Number} fromNumber
   * @param {Number} toNumber
   * @param {String} errorMessage
   */

  /**
   * @type {Number}
   */
  function Range() {
    var fromNumber = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

    var _this2 = this;

    var toNumber = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1000;
    var errorMessage = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';

    _classCallCheck(this, Range);

    var _this = _possibleConstructorReturn(this, (Range.__proto__ || Object.getPrototypeOf(Range)).call(this));

    Object.defineProperty(_this, 'isValid', {
      enumerable: true,
      writable: true,
      value: function value() {
        _newArrowCheck(this, _this2);

        var isValid = false;

        if (_this.value >= _this.fromNumber && _this.value <= _this.toNumber) {
          isValid = true;
        }

        return isValid;
      }.bind(this)
    });


    _this.fromNumber = fromNumber;
    _this.toNumber = toNumber;
    _this.message = 'Number is not in allowed range.';

    if (errorMessage !== '') {
      _this.message = errorMessage;
    }
    return _this;
  }

  /**
   * Validates passed value.
   *
   * @returns {Boolean}
   */


  /**
   * @type {Number}
   */


  return Range;
}(_Constraint3.default);

exports.default = Range;