'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _Constraint2 = require('../Constraint');

var _Constraint3 = _interopRequireDefault(_Constraint2);

var _IsBlank = require('../Basic/IsBlank');

var _IsBlank2 = _interopRequireDefault(_IsBlank);

var _index = require('../../index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _newArrowCheck(innerThis, boundThis) { if (innerThis !== boundThis) { throw new TypeError("Cannot instantiate an arrow function"); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @class ./constraints/Basic/Date
 */
var Date = function (_Constraint) {
    _inherits(Date, _Constraint);

    /**
     * Constructor.
     *
     * @param {String} errorMessage
     */
    function Date() {
        var _this2 = this;

        var errorMessage = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

        _classCallCheck(this, Date);

        var _this = _possibleConstructorReturn(this, (Date.__proto__ || Object.getPrototypeOf(Date)).call(this));

        Object.defineProperty(_this, 'daysInMonth', {
            enumerable: true,
            writable: true,
            value: [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31]
        });
        Object.defineProperty(_this, 'isLeapYear', {
            enumerable: true,
            writable: true,
            value: function value(year) {
                _newArrowCheck(this, _this2);

                var isLeap = false;

                if (!(year % 4) && year % 100 || !(year % 400)) {
                    isLeap = true;
                }

                return isLeap;
            }.bind(this)
        });
        Object.defineProperty(_this, 'isValid', {
            enumerable: true,
            writable: true,
            value: function value() {
                _newArrowCheck(this, _this2);

                var isValid = false;
                var isEmpty = new _IsBlank2.default().setValue(_this.value).isValid();
                var minLength = new _index.MinLength(10).setValue(_this.value).isValid();
                var maxLength = new _index.MaxLength(11).setValue(_this.value).isValid();

                if (!isEmpty && minLength && maxLength) {
                    var bits = _this.value.split(/\.|\/|-/);
                    var y = bits[2],
                        m = bits[1],
                        d = bits[0];

                    if (_this.isLeapYear(y)) {
                        _this.daysInMonth[1] = 29;
                    }

                    if (!/\D/.test(String(d)) && d > 0 && d <= _this.daysInMonth[--m] && y.length === 4) {
                        isValid = true;
                    }
                }

                return isValid;
            }.bind(this)
        });

        _this.message = 'This is not valid date.';

        if (errorMessage !== '') {
            _this.message = errorMessage;
        }
        return _this;
    }

    /**
     * If evenly divisible by 4 and not evenly divisible by 100,
     * or is evenly divisible by 400, then a leap year
     *
     * @param {String} year
     *
     * @Returns {Boolean}
     */

    /**
     * Assumes not leap year by default.
     *
     * @type {Number[]}
     */


    /**
     * Validates passed value.
     *
     * @returns {Boolean}
     */


    return Date;
}(_Constraint3.default);

exports.default = Date;