'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _Constraint2 = require('../Constraint');

var _Constraint3 = _interopRequireDefault(_Constraint2);

var _index = require('../../index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _newArrowCheck(innerThis, boundThis) { if (innerThis !== boundThis) { throw new TypeError("Cannot instantiate an arrow function"); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @class ./constraints/Basic/DateTime
 */
var DateTime = function (_Constraint) {
    _inherits(DateTime, _Constraint);

    /**
     * Constructor.
     *
     * @param {String} errorMessage
     */
    function DateTime() {
        var _this2 = this;

        var errorMessage = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

        _classCallCheck(this, DateTime);

        var _this = _possibleConstructorReturn(this, (DateTime.__proto__ || Object.getPrototypeOf(DateTime)).call(this));

        Object.defineProperty(_this, 'isValid', {
            enumerable: true,
            writable: true,
            value: function value() {
                _newArrowCheck(this, _this2);

                var isValid = false;
                var isEmpty = new _index.IsBlank().setValue(_this.value).isValid();
                var minLength = new _index.MinLength(16).setValue(_this.value).isValid();
                var maxLength = new _index.MaxLength(20).setValue(_this.value).isValid();

                if (!isEmpty && minLength && maxLength) {
                    var bits = _this.value.split(' ');

                    var date = bits[0],
                        time = bits[1];

                    var isValidDate = new _index.Date().setValue(date).isValid();
                    var isValidTime = new _index.Time().setValue(time).isValid();

                    if (isValidDate && isValidTime) {
                        isValid = true;
                    }
                }

                return isValid;
            }.bind(this)
        });

        _this.message = 'This is not valid datetime.';

        if (errorMessage !== '') {
            _this.message = errorMessage;
        }
        return _this;
    }

    /**
     * Validates passed value.
     *
     * @returns {Boolean}
     */


    return DateTime;
}(_Constraint3.default);

exports.default = DateTime;