'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _Constraint2 = require('../Constraint');

var _Constraint3 = _interopRequireDefault(_Constraint2);

var _IsBlank = require('../Basic/IsBlank');

var _IsBlank2 = _interopRequireDefault(_IsBlank);

var _index = require('../../index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _newArrowCheck(innerThis, boundThis) { if (innerThis !== boundThis) { throw new TypeError("Cannot instantiate an arrow function"); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @class ./constraints/Basic/Time
 */
var Time = function (_Constraint) {
    _inherits(Time, _Constraint);

    /**
     * Constructor.
     *
     * @param {String} errorMessage
     */
    function Time() {
        var _this2 = this;

        var errorMessage = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

        _classCallCheck(this, Time);

        var _this = _possibleConstructorReturn(this, (Time.__proto__ || Object.getPrototypeOf(Time)).call(this));

        Object.defineProperty(_this, 'isString', {
            enumerable: true,
            writable: true,
            value: function value(_value) {
                _newArrowCheck(this, _this2);

                var isString = false;

                if (/\D/.test(String(_value))) {
                    isString = true;
                }

                return isString;
            }.bind(this)
        });
        Object.defineProperty(_this, 'isValid', {
            enumerable: true,
            writable: true,
            value: function value() {
                _newArrowCheck(this, _this2);

                var isValid = false;
                var isEmpty = new _IsBlank2.default().setValue(_this.value).isValid();
                var range = new _index.Range(5, 8).setValue(_this.value.length).isValid();

                if (!isEmpty && range) {

                    var bits = _this.value.split(':');
                    var s = bits[2],
                        m = bits[1],
                        h = bits[0];

                    if (!(_this.isString(h) && _this.isString(m)) && parseInt(h) <= 23 && h.length <= 2 && parseInt(m) <= 59 && m.length <= 2) {
                        isValid = true;
                    }
                }

                return isValid;
            }.bind(this)
        });

        _this.message = 'This is not valid time.';

        if (errorMessage !== '') {
            _this.message = errorMessage;
        }
        return _this;
    }

    /**
     * Checks if input value is string.
     *
     * @param value
     * @return {boolean}
     */


    /**
     * Validates passed value.
     *
     * @returns {Boolean}
     */


    return Time;
}(_Constraint3.default);

exports.default = Time;